- commit = @repository.commit(branch.dereferenced_target)
- bar_graph_width_factor = @max_commits > 0 ? 100.0/@max_commits : 0
- diverging_commit_counts = @repository.diverging_commit_counts(branch)
- number_commits_behind = diverging_commit_counts[:behind]
- number_commits_ahead = diverging_commit_counts[:ahead]
- merge_project = can?(current_user, :create_merge_request, @project) ? @project : (current_user && current_user.fork_of(@project))
%li{ class: "js-branch-#{branch.name}" }
  %div
    = link_to namespace_project_tree_path(@project.namespace, @project, branch.name), class: 'item-title str-truncated ref-name' do
      = icon('code-fork')
      = branch.name
    &nbsp;
    - if branch.name == @repository.root_ref
      %span.label.label-primary default
    - elsif @repository.merged_to_root_ref? branch.name
      %span.label.label-info.has-tooltip{ title: "Merged into #{@repository.root_ref}" }
        merged

    - if protected_branch?(@project, branch)
      %span.label.label-success
        protected

    - if @project.mirror_ever_updated_successfully? && @repository.diverged_from_upstream?(branch.name)
      %span.label.label-danger.has-tooltip{ data: { html: "true", title: branch_diverged_tooltip_message } }
        = icon('exclamation-triangle')
        diverged from upstream

    .controls.hidden-xs<
      - if merge_project && create_mr_button?(@repository.root_ref, branch.name)
        = link_to create_mr_path(@repository.root_ref, branch.name), class: 'btn btn-default' do
          Merge request

      - if branch.name != @repository.root_ref
        = link_to namespace_project_compare_index_path(@project.namespace, @project, from: @repository.root_ref, to: branch.name), class: "btn btn-default #{'prepend-left-10' unless merge_project}", method: :post, title: "Compare" do
          Compare

      = render 'projects/buttons/download', project: @project, ref: branch.name, pipeline: @refs_pipelines[branch.name]

      - if can?(current_user, :push_code, @project)
        - if branch.name == @project.repository.root_ref
          %button{ class: "btn btn-remove remove-row js-ajax-loading-spinner has-tooltip disabled",
            disabled: true,
            title: "The default branch cannot be deleted" }
            = icon("trash-o")
        - elsif protected_branch?(@project, branch)
          - if can?(current_user, :delete_protected_branch, @project)
            %button{ class: "btn btn-remove remove-row js-ajax-loading-spinner has-tooltip",
              title: "Delete protected branch",
              data: { toggle: "modal",
                target: "#modal-delete-branch",
                delete_path: namespace_project_branch_path(@project.namespace, @project, branch.name),
                branch_name: branch.name } }
              = icon("trash-o")
          - else
            %button{ class: "btn btn-remove remove-row js-ajax-loading-spinner has-tooltip disabled",
              disabled: true,
              title: "Only a project master or owner can delete a protected branch" }
              = icon("trash-o")
        - else
          = link_to namespace_project_branch_path(@project.namespace, @project, branch.name),
            class: "btn btn-remove remove-row js-ajax-loading-spinner has-tooltip",
            title: "Delete branch",
            method: :delete,
            data: { confirm: "Deleting the '#{branch.name}' branch cannot be undone. Are you sure?" },
            remote: true,
            "aria-label" => "Delete branch" do
            = icon("trash-o")

    - if branch.name != @repository.root_ref
      .divergence-graph{ title: "#{number_commits_ahead} commits ahead, #{number_commits_behind} commits behind #{@repository.root_ref}" }
        .graph-side
          .bar.bar-behind{ style: "width: #{number_commits_behind * bar_graph_width_factor}%" }
          %span.count.count-behind= number_commits_behind
        .graph-separator
        .graph-side
          .bar.bar-ahead{ style: "width: #{number_commits_ahead * bar_graph_width_factor}%" }
          %span.count.count-ahead= number_commits_ahead


  - if commit
    = render 'projects/branches/commit', commit: commit, project: @project
  - else
    %p
      Cant find HEAD commit for this branch
